#include "mbed.h"
#include "BiQuad.h"
#include "stdlib.h"
#include <iostream>
#include <cmath>
#include <string>
#include "HIDScope.h"


AnalogIn   emg0(A0);
AnalogIn   emg1(A1);
DigitalOut led1(LED1);
DigitalOut led3(LED3);
HIDScope  scope( 3 );
int counter;

Ticker  emgticker;

BiQuadChain bqc;
BiQuad bq1( 8.17310e-01, 0.00000e+00, -8.17310e-01, -1.57627e-01, -6.34619e-01 ); //bandpass
BiQuad bq2( 6.68124e-01, -1.27085e+00, 6.68124e-01, -1.27085e+00, 3.36249e-01 ); //notchnotch
//there is a rectifier between these two bqc's
//gives you new highfrequency noise, so lowpass afterwards

BiQuadChain bqc2;
BiQuad bq3( 2.00834e-02, 4.01667e-02, 2.00834e-02, -1.56102e+00, 6.41352e-01 );  //lowpass
 double a;



void Sample ()
{
   

    double emgSignal = emg0.read();


    double emgFiltered1 = bqc.step(emgSignal);              //chain1
    double emgFiltered2 = fabs(emgFiltered1);               //rectifier
    double emgFiltered3 = bqc2.step(emgFiltered2);          //chain2

    scope.set(0, emgSignal);                                //hidscope channel 1
    scope.set(1, emgFiltered3);
    scope.set(2, a);                                       //hidscope channel 2
    scope.send();

    if (counter == 0) {
        a = emgFiltered3;
    }


    if (a >= 0.1)                                            //threshold value

    {

        a = 0;

        led1 = !led1;
        counter++;                                         //change LED on/off
    } else if (a == 0) {
        counter++;

    }

    if (counter == 1000) {
        led3 = !led3;
        counter = 0;
    }


}



int main()
{
    counter = 0;
    led1 = 1; //off
    led3 = 1; //off
    bqc.add( &bq1 ).add( &bq2 );
    bqc2.add( &bq3 );                                       //add both biquad chains
    emgticker.attach(&Sample, 0.001);                       //attach ticker


    while (true) {

    }
}
